# HBACK -- Dispersion correct and linearize spectrum, placing input in Nodisp/
# By Doug Mink, SAO Telescope Date Center
# October 24, 2005

procedure hback (images)

string	images = ""	{prompt="Input multispec image(s) to correct"}
bool	plotspec = yes	{prompt="Plot processed spectra (y or n)"}
bool	deltemp = yes	{prompt="Delete temporary files (y or n)"}
bool	saveold = yes	{prompt="Save original files in Nodisp/ (y or n)"}
bool	verbose = no	{prompt="Log progress (y or n)"}
bool	debug = no	{prompt="Too much info from sumspec (y or n)"}

begin
	bool vb, db
	file imin
	string ims, tchar, templist, arg

	if (!deftask ("sumspec")) {
	    rvsao (motd=no)
	    }

	ims = images
	vb = verbose
	db = debug
	if (db) {
	    vb = yes
	    deltemp = no
	    }

	if (ims == "") {
	    print ("HBACK:  Remove background from spectra in image files")
	    print ("Usage: hback <input images>")
	    return
	    }

#  Make temporary list of input files
	tchar = substr (ims,1,1)
        if (tchar == '@') {
	    templist = substr (ims,2,100)
	    }
	else {
	    templist = mktemp ("linlist")
	    files (ims, >templist)
	    }
#	print (templist)

	hback1.saveold = savedisp
	hback1.verbose = vb
	hback1.debug = db

	list = templist
	while (fscan (list,imin) != EOF) {

# Remove background from individual spectra in input files
	    hback1 (imin)
            }

# Delete list file if temporary and requested
	if (deltemp && tchar != '@') {
	    delete (templist)
	    }

end
# Oct 24 2004	New task based on hlin.cl
