# IMROOT -- Find root of image file name by removing all extensions
# By Doug Mink, SAO Telescope Data Center
# May 24, 2007

procedure imroot (image)

string	image = ""	{prompt="Input image for root"}
string	root = ""	{prompt="Image root name"}
bool	verbose = no	{prompt="Log progress (y or n)"}
bool	debug = no	{prompt="Log progress (y or n)"}

begin
	bool vb, db
	int lroot
	string imroot, imin

	imin = image
	vb = verbose
	db = debug

	if (imin == "") {
	    print ("IMROOT:  Return root image name")
	    print ("Usage: imroot <input image>")
	    return
	    }
	imin = image
	vb = verbose
	db = debug

# Check for FITS multispec files
	smatch (imin, ".ms")
	if (smatch.found) {
	    lroot = smatch.start - 1
	    root = substr (imin, 1, lroot)
	    }

# Check for other FITS files
	else {
	    smatch (imin, ".fits")
	    if (smatch.found) {
		lroot = smatch.start - 1
		root = substr (imin, 1, lroot)
		}

# Check for IRAF imh files
	    else {
		smatch (imin, ".imh")
		if (smatch.found) {
		    lroot = smatch.start - 1
		    root = substr (imin, 1, lroot)
		    }

# If no known suffix, assume to be the root
		else
		    root = imin
		}
	    }
	if (vb)
	    print (root)
end

# Feb 26 2007	New task
# May 24 2007	Default verbose to no
