# File hectospec/Src/t_imgetp.x
# August 23, 2006
# Adaped from images.imgets by Doug Mink, SAO TElescope Data Center

include	<error.h>
include	<imhdr.h>
include	<ctype.h>

# T_IMGETP -- Get the value of an image header parameter as a character string.
# The value is returned as a CL parameter of type string; the type coercion
# facilities of the CL may be used to convert to a different datatype if
# desired.

procedure t_imgetp()

pointer	sp, im
pointer	image, param, value, tvalue
char	comma
bool	clgetb()
bool	verbose
int	i, icomma, itok, ip, nc, lval, pval
int	jtok, j, ltok
pointer	immap()
int	ctoi(), stridx(), clscan(), strlen()

begin
	comma = ','
	call smark (sp)
	call salloc (image, SZ_FNAME, TY_CHAR)
	call salloc (param, SZ_FNAME, TY_CHAR)
	call salloc (value, SZ_LINE,  TY_CHAR)
	call salloc (tvalue, SZ_LINE,  TY_CHAR)
	Memc[value] = EOS

	call clgstr ("image", Memc[image], SZ_FNAME)

	call clgstr ("param", Memc[param], SZ_FNAME)

#  Get token number, if part of parameter name
	icomma = stridx (comma,Memc[param])
	if (icomma > 0) {
	    ip = icomma + 1
	    nc = ctoi (Memc[param],ip,itok)
	    Memc[param+icomma-1] = EOS
	    }
	else {
	    itok = 0
	    }

	verbose = clgetb ("verbose")

	im = immap (Memc[image], READ_ONLY, 0)

	iferr (call imgstr (im, Memc[param], Memc[value], SZ_LINE)) {
	    if (verbose) call erract (EA_WARN)
	    if (clscan("default") != EOF) {
		call clgstr ("default", Memc[value], SZ_LINE)
		call clpstr ("value", Memc[value])
		}
	    else
		call clpstr ("value", "0")
	    }
	else {
	    if (itok > 0) {

#	    Drop leading spaces
		lval = strlen (Memc[value])
		do i = 1, lval {
		    if (Memc[value] != ' ')
			break
		    else
			value = value + 1
		    }

#	    Find desired token
		ip = 1
		pval = 0
		jtok = 0
		ltok = 0
		do j = 0, lval {
		    if (Memc[value+j] == ' ' || Memc[value+j] == EOS) {
			if (ltok > 0) {
			    jtok = jtok + 1
			    if (jtok == itok) {
				ltok = j - pval
				break
				}
			    else {
				pval = j + 1
				ltok = 0
				}
			    }
			else {
			    pval = j + 1
			    ltok = 0
			    }
			}
		    else
			ltok = ltok + 1
		    }
		if (ltok == 0) {
		    call eprintf ("IMGETP:  Token %d not found; only %d\n")
			call pargi (itok)
			call pargi (jtok)
		    return
		    }

		call strcpy (Memc[value+pval], Memc[tvalue], ltok)
		call clpstr ("value", Memc[tvalue])
		if (verbose) {
		    call printf ("%s\n")
		    call pargstr (Memc[tvalue])
		    }
		}
	    else {
		call clpstr ("value", Memc[value])
		if (verbose) {
		    call printf ("%s\n")
		    call pargstr (Memc[value])
		    }
		}
	    }
	call imunmap (im)
	call sfree (sp)
	return
end

# May 31 1995	Add token extraction

# Feb 11 1997	Add default value parameter

# Jun 10 2004	Initialize value to EOS to return null string if keyword not found

# Apr  5 2005	Skip leading spaces when counting tokens

# Aug 23 2006	Include parsing code instead of using IRAF token subroutine
